/*
  This program uses the metro library to blink three different LEDs
  using different time intervals and no pwm.
  See the metro event timers below and code for details.
 */

#include <Metro.h> // Include Metro library

// Pin 13 has the LED on Teensy 3.0

// Custom wiring on the test board, does not conflict with SPI
int yellow_led = 6;
int red_led = 7;
int green_led = 8;


// Declare and instantiate the metro objects
Metro metro_125 = Metro(125);
Metro metro_500 = Metro(500);
Metro metro_1000 = Metro(1000);

// Create the current states for the LEDs
int yellow_state = LOW;
int green_state = LOW;
int red_state = LOW;


// the setup routine runs once when you press reset:
void setup() {                
  // initialize the digital pin as an output.
  pinMode(yellow_led, OUTPUT);    
  pinMode(red_led, OUTPUT);
  pinMode(green_led, OUTPUT);   
  
}

void toggle_yellow()
{
  if (yellow_state == HIGH)
  {
    yellow_state = LOW;
  }
  else
  {
    yellow_state = HIGH;
  }
  digitalWrite(yellow_led, yellow_state);
}

void toggle_green()
{
  if (green_state == HIGH)
  {
    green_state = LOW;
  }
  else
  {
    green_state = HIGH;
  }
  digitalWrite(green_led, green_state);
}

void toggle_red()
{
  if (red_state == HIGH)
  {
    red_state = LOW;
  }
  else
  {
    red_state = HIGH;
  }
  digitalWrite(red_led, red_state);
}

// the loop routine runs over and over again forever:
void loop() {

  if (metro_125.check() == 1)
  {
    toggle_yellow();
  }

  if (metro_500.check() == 1)
  {
    toggle_red();
  }

  if (metro_1000.check() == 1)
  {
    toggle_green();
  }
  
  
}
